**## 版本**

tuya file transfer demo ：1.0.0
(zigbee应用分包组件)



**## 简介**

tdd_file_transfer.c   文件提供了应用层需要定义的收到分包notify后的资源分配函数，分步接收及一帧接收完全的回调函数。

hal_file_transfer.c   文件提供了分包协议帧格式判断，校验及回调app层数据管理接口

**## 功能**

- zigbee应用分包组件，实现超过zcl 负荷上限64字节的数据接收和发送。
- 由于ram限制，数据过长需要实现分步接收，即收到一定量的数据例如：1k则将数据回调给应用层处理，随后释放继续接收数据



**## API使用**

1. 初始化函数，用以开启分包接收，分包发送，快速poll，接收超时结束，发送超时结束功能。其中分包接收，分包发送共用一个软件定时器；快速poll，接收超时结束，发送超时结束功能各用一个定时器。

    ```C

    BOOL_T tdd_file_transfer_init(BOOL_T rec_enable,BOOL_T send_enable,BOOL_T fast_poll,BOOL_T rec_timeout,BOOL_T send_timeout);

    ```


2. 接收到新的一次分包传输的标志，如果是一次可以接受完整的则该标志表示接受完整并回到应用层；如果是需要分步接收的则该标志表示第一次接收buf满回调应用层

    ```C

    BOOL_T rec_new_frame_flag(void);

    ```


3. 收到start notify之后回调应用层，应用层需要强定义实现该函数，用于数据申请，判断是否允许进行分包传输等;output_len为冗余申请长度，应用层实际申请的buf大小需要为output_len+malloc_len

    ```C

    VIRTUAL_FUNC BOOL_T app_start_notify_callback(UINT16_T addr,start_notification_pdu_t pdu,UINT8_T output_len,UINT8_T **input_buf,UINT16_T *malloc_len);

    ```


4. 主动结束数据获取发送end request ，其中status是可以选择的错误类型
 
    ```C

    APP_TRANSFER_EXTERN BOOL_T check_fileid_send_end_request(UINT16_T file_id,END_RESPOND_STATUS_T end_status);

    ```


5. 分包结束回调，将对方信息和fileid上报给应用层，应用层需要强定义实现该函数，用于应用层释放start notify时申请的内存

    ```C

    VIRTUAL_FUNC BOOL_T file_rec_transfer_end_callback(UINT16_T addr,UINT32_T file_id,BOOL_T result,UINT8_T *buf,UINT16_T len);

    ```


6. 主动发起一次分包传输接口  (其中file_id组件自行进行维护，递增，并同步给应用层)，由上层申请数据长度传入。

    ```C

	BOOL_T app_start_send_multiple_packet_handle(UINT16_T addr,UINT16_T cluster,UINT8_T type,UINT8_T cmd,UINT32_T total_size,UINT8_T* data,UINT16_T len,UINT16_T *file_id);

    ```


7. 主动结束数据发送，不再发送block respond

    ```C

    BOOL_T stop_send_stop_block_respond(void);

    ```


8. 数据发送结束后，组件会回调该函数通知应用层，应用层需要强定义实现该函数，用于资源释放和状态同步

    ```C

    VIRTUAL_FUNC BOOL_T file_send_transfer_end_callback(UINT16_T addr,UINT32_T file_id,BOOL_T result,UINT8_T *buf,UINT16_T len);

    ```


**## 大文件传输分包协议详见链接**

https://wiki.tuya-inc.com:7799/pages/viewpage.action?pageId=72241704&preview=/72241704/72241705/zigbee%E5%A4%A7%E6%96%87%E4%BB%B6%E4%BC%A0%E8%BE%93%E6%96%B9%E6%A1%88.docx



**## cluster及attr注册参考**

    ```C

    #define MULTIPLE_PACKET_TRANSFER_ATTR_LIST \
        { 0xFFFD, ATTR_INT16U_ATTRIBUTE_TYPE, 2, (ATTR_MASK_SINGLETON),  (UINT8_T*)0x0001  }, /* tuya large file transfer / cluster revision*/

    #define DEF_CLUSTER_MULTIPLE_PACKET_TRANSFER_CLUSTER_ID(a) \
        { CLUSTER_MULTIPLE_PACKET_TRANSFER_CLUSTER_ID , (attr_t *)&((a)[0]), get_array_len((a)) },

    const attr_t g_multiple_packet_transfer_attr_list[] = {
        MULTIPLE_PACKET_TRANSFER_ATTR_LIST
    };

    DEF_CLUSTER_MULTIPLE_PACKET_TRANSFER_CLUSTER_ID(g_multiple_packet_transfer_attr_list)

    ```
