#ifndef __APP_COMMON_H__
#define __APP_COMMON_H__

#ifdef __cplusplus
extern "C"
{
#endif
#include <string.h>
#include "tkl_uart.h"
#include "tal_sw_timer.h"
#include "tuya_cloud_types.h"
#include "tuya_zigbee_stack.h"

/**************************************************************************
 *                              global  variable
 * ************************************************************************/
#define USER_KEY0           TUYA_GPIO_NUM_16//PC0
#define NET_STATUS_LED0     TUYA_GPIO_NUM_18//PC2

#define USER_UART0          TUYA_UART_NUM_0

#define ZIGBEE_JOIN_MAX_TIMEOUT         (180*1000)

#define OPTION_ATTRIBUTE_ID             0x000F


///< Command types for cluster: IR control Cluster
///< Cluster specification level: UNKNOWN

///< Client to server
#define CMD_IR_STUDY_KEYCODE_COMMAND_ID 0x04 ///< Ver.: always
#define CMD_IR_REPORT_KEYID_COMMAND_ID 0x05 ///< Ver.: always


///< Command types for cluster: IR control Cluster
///< Cluster specification level: UNKNOWN

///< Server to client
#define CMD_IR_STUDY_STATUS_COMMAND_ID 0x00 ///< Ver.: always
#define CMD_IR_KEYID_CONTROL_COMMAND_ID 0x01 ///< Ver.: always
#define CMD_IR_KEYCODE_SEND_COMMAND_ID 0x02 ///< Ver.: always
#define CMD_IR_DELETE_KEYCODE_COMMAND_ID 0x03 ///< Ver.: always
#define CMD_IR_KEYCODE_IMMEDIATE_DOWNLOAD_COMMAND_ID 0x06 ///< Ver.: always
#define CMD_IR_KEYCODE_REPLACE_COMMAND_ID 0x07 ///< Ver.: always
#define CMD_IR_KEYCODE_DELAY_DOWNLOAD_COMMAND_ID 0x08 ///< Ver.: always

typedef enum
{
    ZIGBEE_CMD_SINGLE = 0,
    ZIGBEE_CMD_GROUP
} ZIGBEE_CMD_T;

/**************************************************************************
 *                              init functions
 * ************************************************************************/

/**************************************************************************
 *                          software timer functions
 * ************************************************************************/

  /**************************************************************************
 *                        pwm functions
 * ************************************************************************/

VOID_T app_button_init(VOID_T);
VOID_T app_status_led_init(VOID_T);
VOID_T dev_uart_output(IN CONST CHAR_T *str);
VOID_T app_button_scan_cb(TIMER_ID timer_id, VOID_T *arg);

VOID_T status_led_stop_blink(BOOL_T onoff);
VOID_T status_led_start_blink(BOOL_T onoff);

/**************************************************************************
 *                          flash functions
 * ************************************************************************/


#ifdef __cplusplus
}
#endif

#endif
